<script setup lang="ts">
import { z } from 'zod'
import Entry from '~/components/app/soapi/entry.vue'
import Action from '~/components/pub/my-ui/nav-footer/ba-dr-su.vue'
import ActionDialog from '~/components/pub/my-ui/nav-footer/ba-su.vue'
import Dialog from '~/components/pub/my-ui/modal/dialog.vue'
import { EarlyRehabSchema } from '~/schemas/soapi.schema'
import { toast } from '~/components/pub/ui/toast'
import { handleActionSave, handleActionEdit } from '~/handlers/soapi-early.handler'
const { backToList } = useQueryMode('mode')

const route = useRoute()
const isOpenProcedure = ref(false)
const isOpenDiagnose = ref(false)
const procedures = ref([])
const diagnoses = ref([])
const selectedProcedure = ref<any>(null)
const selectedDiagnose = ref<any>(null)
const schema = EarlyRehabSchema
const payload = ref({
  encounter_id: 0,
  time: '',
  typeCode: 'early-rehab',
  value: '',
})
const model = ref({
  'prim-compl': '',
  'medical-plan': '',
  'diagnosis-medical': '',
  'rehab-trouble': '',
  'medical-trouble': '',
  'physic-modal': '',
  exercise: '',
  'ortho-pesa': '',
  education: '',
  other: '',
  cranialis: '',
  sensoris: '',
  'reflect-fisio': '',
  'reflect-pato': '',
  otonom: '',
  localis: '',
  'medical-trial': '',
  therapy: '',
  'syst-bp': '',
  'diast-bp': '',
  pulse: '',
  gcs: '',
  'respiratory-rate': '',
  temperature: '',
  ambulance: '',
  gait: '',
  'neck-rom': '',
  'body-rom': '',
  'aga-rom': '',
  'agb-rom': '',
  'neck-mmt': '',
  'body-mmt': '',
  'aga-mmt': '',
  'agb-mmt': '',
  localis: '',
  'medical-trouble': '',
  'rehab-trouble': '',
  temp: '',
  spo2: '',
  weight: '',
  height: '',
})

const isLoading = reactive<DataTableLoader>({
  isTableLoading: false,
})

async function getDiagnoses() {
  isLoading.isTableLoading = true
  const resp = await xfetch('/api/v1/diagnose-src')
  if (resp.success) {
    diagnoses.value = (resp.body as Record<string, any>).data
  }
  isLoading.isTableLoading = false
}

async function getProcedures() {
  isLoading.isTableLoading = true
  const resp = await xfetch('/api/v1/procedure-src')
  if (resp.success) {
    procedures.value = (resp.body as Record<string, any>).data
  }
  isLoading.isTableLoading = false
}

onMounted(() => {
  getProcedures()
  getDiagnoses()
})

function handleOpen(type: string) {
  if (type === 'fungsional') {
    isOpenDiagnose.value = true
  }
}

const entryRehabRef = ref()
async function actionHandler(type: string) {
  if (type === 'back') {
    backToList()
    return
  }
  const result = await entryRehabRef.value?.validate()
  if (result?.valid) {
    if (selectedDiagnose.value?.length > 0) {
      result.data.diagnose = selectedDiagnose.value || []
    }
    console.log('data', result.data)
    handleActionSave(
      {
        ...payload.value,
        value: JSON.stringify(result.data),
        encounter_id: +route.params.id,
        time: new Date().toISOString(),
      },
      {},
      toast,
    )
  } else {
    console.log('Ada error di form', result)
  }
}

const icdPreview = ref({
  procedures: [],
  diagnoses: [],
})

function actionDialogHandler(type: string) {
  if (type === 'submit') {
    icdPreview.value.procedures = selectedProcedure.value || []
    icdPreview.value.diagnoses = selectedDiagnose.value || []
  }
  isOpenProcedure.value = false
  isOpenDiagnose.value = false
}

provide('table_data_loader', isLoading)
provide('icdPreview', icdPreview)
</script>
<template>
  <Entry
    ref="entryRehabRef"
    v-model="model"
    :schema="schema"
    type="early-rehab"
    @click="handleOpen"
  />
  <div class="my-2 flex justify-end py-2">
    <Action @click="actionHandler" />
  </div>
  <Dialog
    v-model:open="isOpenDiagnose"
    title="Pilih Fungsional"
    size="xl"
    prevent-outside
  >
    <AppIcdMultiselectPicker
      v-model:model-value="selectedDiagnose"
      :data="diagnoses"
    />
    <div class="my-2 flex justify-end py-2">
      <ActionDialog @click="actionDialogHandler" />
    </div>
  </Dialog>
</template>
